# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _permittivity
else:
    import _permittivity

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import ooflib.SWIG.engine.property
import ooflib.SWIG.engine.symmmatrix
import ooflib.SWIG.engine.outputval
import ooflib.SWIG.engine.fieldindex
import ooflib.SWIG.engine.planarity
import ooflib.SWIG.engine.IO.propertyoutput
import ooflib.SWIG.engine.mastercoord
class IsoDielectricPermittivity(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, epsilon):
        _permittivity.IsoDielectricPermittivity_swiginit(self, _permittivity.new_IsoDielectricPermittivity(reg, name, epsilon))
    __swig_destroy__ = _permittivity.delete_IsoDielectricPermittivity

# Register IsoDielectricPermittivity in _permittivity:
_permittivity.IsoDielectricPermittivity_swigregister(IsoDielectricPermittivity)
class AnisoDielectricPermittivity(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, k):
        _permittivity.AnisoDielectricPermittivity_swiginit(self, _permittivity.new_AnisoDielectricPermittivity(reg, name, k))
    __swig_destroy__ = _permittivity.delete_AnisoDielectricPermittivity

# Register AnisoDielectricPermittivity in _permittivity:
_permittivity.AnisoDielectricPermittivity_swigregister(AnisoDielectricPermittivity)
class ChargeDensity(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, qdot):
        _permittivity.ChargeDensity_swiginit(self, _permittivity.new_ChargeDensity(reg, name, qdot))

    def rho(self):
        return _permittivity.ChargeDensity_rho(self)
    __swig_destroy__ = _permittivity.delete_ChargeDensity

# Register ChargeDensity in _permittivity:
_permittivity.ChargeDensity_swigregister(ChargeDensity)
# -*- python -*-

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov. 


from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.common.IO import xmlmenudump
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.SWIG.engine import symmmatrix

PropertyRegistration = propertyregistration.PropertyRegistration

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Isotropic',
    IsoDielectricPermittivity,
    ordering=98,
    params=[parameter.FloatParameter('epsilon',
                                     1.0, tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Isotropic dielectric permittivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/isopermittivity.xml')
    )

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## TRICLINIC

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Triclinic',
    AnisoDielectricPermittivity,
    105,
    params=[symmmatrix.TriclinicRank2TensorParameter(
        'epsilon',
        symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],   
    propertyType="DielectricPermittivity",
    tip="Triclinic dielectric permittivity",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## MONOCLINIC

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Monoclinic',
    AnisoDielectricPermittivity,
    104,
    params=[symmmatrix.MonoclinicRank2TensorParameter(
        'epsilon',
        symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Monoclinic dielectric permittivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## ORTHORHOMBIC

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Orthorhombic',
    AnisoDielectricPermittivity,
    103,
    params=[symmmatrix.OrthorhombicRank2TensorParameter(
        'epsilon',
        symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Orthorhombic dielectric permittivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## TETRAGONAL

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Tetragonal',
    AnisoDielectricPermittivity,
    101,
    params=[symmmatrix.TetragonalRank2TensorParameter(
        'epsilon',
        symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Tetragonal dielectric permittivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## TRIGONAL

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Trigonal',
    AnisoDielectricPermittivity,
    102,
    params=[symmmatrix.TrigonalRank2TensorParameter(
        'epsilon',
        symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Trigonal dielectric permittivity",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## HEXAGONAL

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Hexagonal',
    AnisoDielectricPermittivity,
    100,
    params=[symmmatrix.HexagonalRank2TensorParameter(
        'epsilon',
        symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Hexagonal dielectric permittivity",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## CUBIC

reg = PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Cubic',
    AnisoDielectricPermittivity,
    99,
    params=[symmmatrix.CubicRank2TensorParameter(
        'epsilon',
        symmmatrix.CubicRank2Tensor(xx=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Energy", "Material Constants:Electric:Dielectric Permittivity epsilon"],
    propertyType="DielectricPermittivity",
    tip="Cubic dielectric permittivity",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisopermittivity.xml'))

reg.fluxInfo(fluxes=[problem.Total_Polarization], fields=[problem.Voltage],
             time_derivs=[0])

## *Electric* BODY forces (sorry Andrew... --REG)

reg = PropertyRegistration(
    'Electric:SpaceCharge', ChargeDensity,
    150,
    params=[
        parameter.FloatParameter('charge', 0.0, 
                                 tip="electrostatic charge density")],
    outputs=["Material Constants:Electric:Space Charge"],
    propertyType="ChargeDensity",
    tip="Spatial charge density",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/spacecharge.xml'))


reg.eqnInfo(equations=[problem.CoulombEquation])


