# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _thermalexpansion
else:
    import _thermalexpansion

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import ooflib.SWIG.engine.property
import ooflib.SWIG.engine.symmmatrix
import ooflib.SWIG.engine.outputval
import ooflib.SWIG.engine.fieldindex
import ooflib.SWIG.engine.planarity
import ooflib.SWIG.engine.IO.propertyoutput
import ooflib.SWIG.engine.mastercoord
class IsotropicThermalExpansion(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, alpha, t0):
        _thermalexpansion.IsotropicThermalExpansion_swiginit(self, _thermalexpansion.new_IsotropicThermalExpansion(reg, name, alpha, t0))
    __swig_destroy__ = _thermalexpansion.delete_IsotropicThermalExpansion

# Register IsotropicThermalExpansion in _thermalexpansion:
_thermalexpansion.IsotropicThermalExpansion_swigregister(IsotropicThermalExpansion)
class AnisotropicThermalExpansion(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, registry, name, alpha, t0):
        _thermalexpansion.AnisotropicThermalExpansion_swiginit(self, _thermalexpansion.new_AnisotropicThermalExpansion(registry, name, alpha, t0))
    __swig_destroy__ = _thermalexpansion.delete_AnisotropicThermalExpansion

# Register AnisotropicThermalExpansion in _thermalexpansion:
_thermalexpansion.AnisotropicThermalExpansion_swigregister(AnisotropicThermalExpansion)
# -*- python -*-

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov. 


from ooflib.SWIG.engine import symmmatrix
from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.common.IO import xmlmenudump
from ooflib.engine import problem
from ooflib.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

T0tip = "Temperature at which the thermal expansion vanishes."
#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Isotropic', IsotropicThermalExpansion,
    200,
    [parameter.FloatParameter('alpha', 1.0,
                              tip="Thermal expansion coefficient."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Isotropic thermal expansion',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/isothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Triclinic',
    AnisotropicThermalExpansion,
    210,
    [symmmatrix.TriclinicRank2TensorParameter(
            'alpha',
            symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Triclinic thermal expansion',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature], 
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Monoclinic',
    AnisotropicThermalExpansion,
    209,
    [symmmatrix.MonoclinicRank2TensorParameter(
            'alpha',
            symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Monoclinic thermal expansion.',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Orthorhombic',
    AnisotropicThermalExpansion,
    208,
    [symmmatrix.OrthorhombicRank2TensorParameter(
            'alpha',
            symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Orthorhombic thermal expansion.',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Tetragonal',
    AnisotropicThermalExpansion,
    207,
    [symmmatrix.TetragonalRank2TensorParameter(
            'alpha',
            symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Tetragonal thermal expansion.',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Trigonal',
    AnisotropicThermalExpansion,
    206,
    [symmmatrix.TrigonalRank2TensorParameter(
            'alpha',
            symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Trigonal thermal expansion.',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Hexagonal',
    AnisotropicThermalExpansion,
    205,
    [symmmatrix.HexagonalRank2TensorParameter(
            'alpha',
            symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Hexagonal thermal expansion.',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Cubic',
    AnisotropicThermalExpansion,
    204,
    [symmmatrix.CubicRank2TensorParameter(
            'alpha',
            symmmatrix.CubicRank2Tensor(xx=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip=T0tip)],
    outputs=["Strain", "Energy",
             "Material Constants:Couplings:Thermal Expansion alpha",
             "Material Constants:Couplings:Thermal Expansion T0"],
    propertyType="ThermalExpansion",
    tip='Cubic thermal expansion.',
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisothermalexp.xml'))

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])


